% function p=GenerateDistribution(siz,alpha)
%
% This function generates a radial distribution for Fourier sampling.
function p=GenerateDistribution(siz,alpha)

n1=siz(1);
n2=siz(2);

[X,Y]=meshgrid(-n1/2:n1/2-1,-n2/2:n2/2-1);

p=1./(sqrt(X.^2+Y.^2).^alpha+1);
p=p/sum(p(:));
p=ifftshift(p);