%function I=GenerateRandomSet(m,p)
%
% This function generates a random set I of m elements with distribution p.
% The indices that appear many times are removed. Therefore, |I|<=m.
function I=GenerateRandomSet(m,p)

p=p/sum(p(:));
dist=cumsum(p);
rng(1); % Initializes the random number generator with the same seed
r=rand(m,1);
r=sort(r);

I=zeros(m,1);
i=1;
for ind=1:length(dist);
    while (i<=m && r(i)<=dist(ind))
        I(i)=ind;
        i=i+1;
    end
end

I=unique(I);
I(I==0)=[];


