u=double(imread('cameraman.tif'));
%u=double(imread('mri.tif'));
% u=double(imread('moon.tif'));
% u=double(imread('AT3_1m4_01.tif'));
% 
% n=1024;
% [X,Y]=meshgrid(linspace(-1,1,n),linspace(-1,1,n));
% u=double(X.^2+Y.^2<=1/2);

figure(1);colormap gray;imagesc(u);title('Image to process')

%% Test of the wavelet transform
addpath(genpath('./rwt-master/bin/'));
h = daubcqf(10,'min');  %Generates a wavelet filter
J = 4;  %Decomposition level
[x,~] = mdwt(u,h,J); %Wavelet decomposition
[u_,~] = midwt(x,h,J); %Wavelet synthesis

figure(2);colormap gray;imagesc(x);title('Wavelet decomposition')
figure(3);colormap gray;imagesc(u_);title('Wavelet synthesis')

%% Test of wavelet compression
[~,I] = sort(abs(x(:)),'Descend');
xc=zeros(size(x));
rate=5/100;
xc(I(1:floor(numel(x)*rate))) = x(I(1:floor(numel(x)*rate))); % only keeps the 1% largest coefficients
[uc,~] = midwt(xc,h,J); %Wavelet synthesis
figure(4);colormap gray;imagesc(abs(xc)>0);
title('Location of the kept coefficients')
figure(5);colormap gray;imagesc(uc);
title(sprintf('Compressed image with a ratio of %1.2e',rate))

%% Test of Fourier transform
fu=fft2(u); %Fast Fourier transform of u
figure(6);colormap gray;imagesc(fftshift(abs(fu)));
figure(7);colormap gray;imagesc(fftshift(log10(max(abs(fu),1e-15))));
title('Fourier transform of u');
u_=ifft2(fu); %Inverse Fourier transform
figure(8);colormap gray;imagesc(u_);
title('Inversion of Fourier transform');
close all;

%% Generate a sampling scheme
alpha=2;
p=GenerateDistribution(size(u),alpha);
m=numel(u);
I=GenerateRandomSet(m,p(:));

sampling_mask=zeros(size(u));
sampling_mask(I)=1;
% Fftshift is just used to display the low frequencies at the center.
figure(1);colormap gray;imagesc(fftshift(sampling_mask));
title(sprintf('Sampling mask -- Ratio of sampled locations %1.2e',numel(I)/numel(u)));

%% Pseudo-inverse
% Sampled data

y=sampling_mask.*fft2(u);

% Operator definition
Phi = @(x) fft2(midwt(x,h,J));
PhiT = @(y) midwt(ifft2(y),h,J);

%Reconstruction by pseudo-inverse
x_pseudoinverse= PhiT(y);

figure(2);colormap gray;imagesc(mdwt(x_pseudoinverse,h,J));
title('Image reconstructed from the pseudo-inverse')




